!*******************************************************************************
! Small test program for the fortran module interfacing the GD library.
! Make sure the variable character 'font' refers to an existing font file!
!*******************************************************************************


program test

use gd

implicit none
type(gd_image)            :: image
integer                   :: c1,c2,c3,c4,c5
integer                   :: a1(4),a2(4)
real(rp)                  :: ptsize = 30.0_rp
real(rp)                  :: angle = 0.0_rp
integer                   :: w,h
character(*), parameter   :: font = "/usr/local/share/my_ttf_fonts/arial.ttf"
character(*), parameter   :: string = "0123456789&#193;BCDE...Z"
integer                   :: r,x,y,status


a1(:) = (/ 5,47,12,55 /)
a2(:) = (/ 36,60,2,25 /)


 call gd_create_img(64,64,image)
 call gd_allocate_color(image,0,0,0,c1)
 call gd_allocate_color(image,255,255,255,c2)
 call gd_allocate_color(image,255,0,0,c3)
 call gd_allocate_color(image,255,0,255,c4)
 call gd_allocate_color(image,0,255,0,c5)
 call gd_draw_line(image,1,1,64,64,c2)
 call gd_draw_rectangle(image,10,10,53,53,c2)
 call gd_draw_filled_rectangle(image,30,30,43,53,c3)
 call gd_draw_string_up(image,gd_font_large(),0,20,'NN',c2)
 call gd_draw_filled_polygon(image,4,a1,a2,c4)
 call gd_fill(image,1,5,c5)
 call gd_write_img_as_png(image,"xxx.png")
 call gd_destroy_img(image)
 call gd_create_img_from_png("bbb",image)
 call gd_write_img_as_png(image,"bbb-from-png.png")
 call gd_destroy_img(image)
 write(6,*) 'test png'

#ifndef WITHOUT_JPEG
 call gd_create_img_from_jpeg("bbb.jpg",image)
 call gd_write_img_as_png(image,"bbb-from-jpeg.png")
 call gd_write_img_as_png(image,"bbb-from-jpeg.jpg")
 call gd_destroy_img(image)
 write(6,*) 'test jpg'
#endif

#ifndef WITHOUT_GIF
 call gd_create_img_from_gif("bbb.gif",image)
 call gd_write_img_as_png(image,"bbb-from-gif.png")
 call gd_write_img_as_gif(image,"bbb-from-gif.gif")
 call gd_destroy_img(image)
 write(6,*) 'test gif'
#endif

#ifndef WITHOUT_FT
 angle = angle*acos(-1.0_rp)/180.0
 call gd_ft_string_size(font,ptsize,string,w,h)
 call gd_create_img(w+6,h+6,image,status)
 call gd_allocate_color(image,0,0,0,c1)
 call gd_allocate_color(image,255,255,255,c2)
 call gd_allocate_color(image,255,0,0,c3)
 x = 3
 y = h + 3
 call gd_draw_ft_string(image,c3,font,ptsize,angle,x,y,string,r)
 call gd_write_img_as_png(image,"yyy.png")
 call gd_destroy_img(image)
 write(6,*) 'test ft'
#endif

#ifndef WITHOUT_XPM
 call gd_create_img_from_xpm("bbb.xpm",image)
 call gd_write_img_as_png(image,"bbb-from-xpm.png")
 call gd_destroy_img(image)
 write(6,*) 'test xpm'
#endif

end program
